## ros-rolling-rmf-traffic-ros2 1.4.0

=== debian/changelog ===
ros-rolling-rmf-traffic-ros2 (1.4.0-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Grey <grey@openrobotics.org>  Mon, 06 Sep 2021 05:05:30 -0000
